'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _map = require('rxjs/operator/map');

var _filter = require('rxjs/operator/filter');

var _ignoreElements = require('rxjs/operator/ignoreElements');

var _reduxSubspace = require('redux-subspace');

var _subspaceStoreKey = require('./subspaceStoreKey');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * Copyright 2017, IOOF Holdings Limited.
                                                                                                                                                                                                                              * All rights reserved.
                                                                                                                                                                                                                              *
                                                                                                                                                                                                                              * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                              * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                              */


var identity = function identity(x) {
    return x;
};

var subspaced = function subspaced(mapState, namespace) {
    var subspaceDecorator = (0, _reduxSubspace.subspace)(mapState, namespace);
    return function (epic) {
        return function (action$, store) {
            var _context;

            var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

            var parentStore = _ref[_subspaceStoreKey.SUBSPACE_STORE_KEY],
                dependencies = _objectWithoutProperties(_ref, [_subspaceStoreKey.SUBSPACE_STORE_KEY]);

            if (parentStore === undefined) {
                throw new Error('Subspace epic couldn\'t find the store. Make sure you\'ve used createEpicMiddleware from redux-subspace-observable');
            }
            var subspacedStore = subspaceDecorator(parentStore);

            Object.defineProperty(dependencies, _subspaceStoreKey.SUBSPACE_STORE_KEY, {
                enumerable: false,
                configurable: false,
                writable: false,
                value: subspacedStore
            });

            var filteredAction$ = (_context = _map.map.call(action$, function (action) {
                return subspacedStore.processAction(action, identity);
            }), _filter.filter).call(_context, identity);

            return (_context = (_context = epic(filteredAction$, subspacedStore, dependencies), _map.map).call(_context, subspacedStore.dispatch), _ignoreElements.ignoreElements).call(_context);
        };
    };
};

exports.default = subspaced;